//Sorting and Searching CPU Speed Tests Sorters.h
//Alex McAlpine www.BrainLubeOnline.com 01/11/2023


//Preprocessor Directives



//Global Variables



//Function Prototypes

void selectionSort(int arr[], int n);
void bubbleSort(int arr[], int n);

//Optimize in Flash Memory if Available



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////CHARGING////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Done in CommandLine.h to make use of random number generator (Hardware)

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////SORTING/////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//Bubble Sort Iterative

void bubbleSort(int arr[], int n) //Where n is the number of elements in the array
  {
    for (int i = 0; i < n-1; i++)
      {
        for (int j = 0; j < n-i-1; j++)
          {
            if (arr[j] > arr[j+1])
              {
                int temp = arr[j];
                arr[j] = arr[j+1];
                arr[j+1] = temp;
              }//END if
          }//END Inner for
      }//END Outter for
  }//END bubbleSort Function




//Selection Sort Iterative

void selectionSort(int arr[], int n)
  {
    int i, j, minIndex, temp;
    for (i = 0; i < n-1; i++)
      {
        minIndex = i;
        for (j = i+1; j < n; j++)
          {
            if (arr[j] < arr[minIndex])
              {
                minIndex = j;
              }//END if
          }//END Inner for
          
    temp = arr[minIndex];
    arr[minIndex] = arr[i];
    arr[i] = temp;
    }//END Outter for
  }//END selectionSort Function




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////SEARCHING///////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
