/*
 * EMIC ARMCOR v.2 Alex McAlpine www.BrainLubeOnline.com
 * Serial Command Line with Parallax Speech Processor and Teensy 4.0
 * 
 */

//Preprocessor Directives

#include "CommandLine.h"          //For serial command line




//Boot
void setup()
{
  pinMode(ledPin, OUTPUT);        //On-Board Status LED
  pinMode(rxPin, INPUT);          //Serial data bus for EMIC Output
  pinMode(txPin, OUTPUT);         //Serial data bus for EMIC Input
  
  digitalWrite(ledPin, LOW);      // Status LED OFF
  
  Serial.begin(57600);             // USB is always 12 Mbit/sec

}

void loop() {
  // put your main code here, to run repeatedly:

  bool received = getCommandLineFromSerialPort(CommandLine);      //global CommandLine is defined in CommandLine.h
  if (received) DoMyCommand(CommandLine);

}
